LUInstanceCreate: Release node resource lock
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN = $(top_srcdir)/autotools/check-man
26 CHECK_VERSION = $(top_srcdir)/autotools/check-version
27 CHECK_NEWS = $(top_srcdir)/autotools/check-news
28 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
29 DOCPP = $(top_srcdir)/autotools/docpp
30 REPLACE_VARS_SED = autotools/replace_vars.sed
31 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
32 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
33
34 # Note: these are automake-specific variables, and must be named after
35 # the directory + 'dir' suffix
36 clientdir = $(pkgpythondir)/client
37 hypervisordir = $(pkgpythondir)/hypervisor
38 httpdir = $(pkgpythondir)/http
39 masterddir = $(pkgpythondir)/masterd
40 confddir = $(pkgpythondir)/confd
41 rapidir = $(pkgpythondir)/rapi
42 serverdir = $(pkgpythondir)/server
43 watcherdir = $(pkgpythondir)/watcher
44 impexpddir = $(pkgpythondir)/impexpd
45 utilsdir = $(pkgpythondir)/utils
46 toolsdir = $(pkglibdir)/tools
47 iallocatorsdir = $(pkglibdir)/iallocators
48 pytoolsdir = $(pkgpythondir)/tools
49 docdir = $(datadir)/doc/$(PACKAGE)
50
51 # Delete output file if an error occurred while building it
52 .DELETE_ON_ERROR:
53
54 HTOOLS_DIRS = \
55         htools \
56         htools/Ganeti \
57         htools/Ganeti/HTools \
58         htools/Ganeti/HTools/Program
59
60 DIRS = \
61         autotools \
62         daemons \
63         devel \
64         doc \
65         doc/examples \
66         doc/examples/hooks \
67         doc/examples/gnt-debug \
68         $(HTOOLS_DIRS) \
69         lib \
70         lib/client \
71         lib/build \
72         lib/confd \
73         lib/http \
74         lib/hypervisor \
75         lib/impexpd \
76         lib/masterd \
77         lib/rapi \
78         lib/server \
79         lib/tools \
80         lib/utils \
81         lib/watcher \
82         man \
83         qa \
84         test \
85         test/data \
86         test/data/ovfdata \
87         test/data/ovfdata/other \
88         tools
89
90 BUILDTIME_DIR_AUTOCREATE = \
91         scripts \
92         $(APIDOC_DIR) \
93         $(APIDOC_PY_DIR) \
94         $(APIDOC_HS_DIR) \
95         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
96         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
97         $(COVERAGE_DIR) \
98         $(COVERAGE_PY_DIR) \
99         $(COVERAGE_HS_DIR) \
100         .hpc
101
102 BUILDTIME_DIRS = \
103         $(BUILDTIME_DIR_AUTOCREATE) \
104         doc/html
105
106 DIRCHECK_EXCLUDE = \
107         $(BUILDTIME_DIRS) \
108         ganeti-[0-9]*.[0-9]*.[0-9]* \
109         doc/html/_*
110
111 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
112
113 # some helper vars
114 COVERAGE_DIR = doc/coverage
115 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
116 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
117 APIDOC_DIR = doc/api
118 APIDOC_PY_DIR = $(APIDOC_DIR)/py
119 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
120
121 MAINTAINERCLEANFILES = \
122         $(docpng) \
123         $(maninput) \
124         doc/install-quick.rst \
125         doc/news.rst \
126         doc/upgrade.rst \
127         vcs-version
128
129 maintainer-clean-local:
130         rm -rf $(BUILDTIME_DIRS)
131
132 CLEANFILES = \
133         $(addsuffix /*.py[co],$(DIRS)) \
134         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
135         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
136         $(all_dirfiles) \
137         $(PYTHON_BOOTSTRAP) \
138         epydoc.conf \
139         autotools/replace_vars.sed \
140         daemons/daemon-util \
141         daemons/ganeti-cleaner \
142         devel/upload \
143         $(BUILT_EXAMPLES) \
144         doc/examples/bash_completion \
145         lib/_generated_rpc.py \
146         $(man_MANS) \
147         $(manhtml) \
148         tools/kvm-ifup \
149         stamp-srclinks \
150         $(nodist_pkgpython_PYTHON) \
151         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
152         .hpc/*.mix htools/*.tix \
153         doc/hs-lint.html
154
155 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
156 # it'll cause the target to rebuild every time.
157 BUILT_SOURCES = \
158   $(built_base_sources) \
159         $(BUILT_PYTHON_SOURCES) \
160         $(PYTHON_BOOTSTRAP)
161
162 built_base_sources = \
163         ganeti \
164         stamp-srclinks \
165         $(all_dirfiles)
166
167 built_python_base_sources = \
168         lib/_autoconf.py \
169         lib/_vcsversion.py
170
171 BUILT_PYTHON_SOURCES = \
172         $(built_python_base_sources) \
173         lib/_generated_rpc.py
174
175 # Generating the RPC wrappers depends on many things, so make sure it's built at
176 # the end of the built sources
177 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
178
179 # these are all built from the underlying %.in sources
180 BUILT_EXAMPLES = \
181         doc/examples/ganeti-kvm-poweroff.initd \
182         doc/examples/ganeti.cron \
183         doc/examples/ganeti.initd \
184         doc/examples/gnt-config-backup \
185         doc/examples/hooks/ipsec
186
187 nodist_pkgpython_PYTHON = \
188         $(BUILT_PYTHON_SOURCES)
189
190 noinst_PYTHON = \
191         lib/build/__init__.py \
192         lib/build/sphinx_ext.py
193
194 pkgpython_PYTHON = \
195         lib/__init__.py \
196         lib/asyncnotifier.py \
197         lib/backend.py \
198         lib/bdev.py \
199         lib/bootstrap.py \
200         lib/cli.py \
201         lib/cmdlib.py \
202         lib/compat.py \
203         lib/config.py \
204         lib/constants.py \
205         lib/daemon.py \
206         lib/errors.py \
207         lib/ht.py \
208         lib/jqueue.py \
209         lib/jstore.py \
210         lib/locking.py \
211         lib/luxi.py \
212         lib/mcpu.py \
213         lib/netutils.py \
214         lib/objects.py \
215         lib/opcodes.py \
216         lib/ovf.py \
217         lib/qlang.py \
218         lib/query.py \
219         lib/rpc.py \
220         lib/rpc_defs.py \
221         lib/runtime.py \
222         lib/serializer.py \
223         lib/ssconf.py \
224         lib/ssh.py \
225         lib/storage.py \
226         lib/uidpool.py \
227         lib/workerpool.py
228
229 client_PYTHON = \
230         lib/client/__init__.py \
231         lib/client/gnt_backup.py \
232         lib/client/gnt_cluster.py \
233         lib/client/gnt_debug.py \
234         lib/client/gnt_group.py \
235         lib/client/gnt_instance.py \
236         lib/client/gnt_job.py \
237         lib/client/gnt_node.py \
238         lib/client/gnt_os.py
239
240 hypervisor_PYTHON = \
241         lib/hypervisor/__init__.py \
242         lib/hypervisor/hv_base.py \
243         lib/hypervisor/hv_chroot.py \
244         lib/hypervisor/hv_fake.py \
245         lib/hypervisor/hv_kvm.py \
246         lib/hypervisor/hv_lxc.py \
247         lib/hypervisor/hv_xen.py
248
249 rapi_PYTHON = \
250         lib/rapi/__init__.py \
251         lib/rapi/baserlib.py \
252         lib/rapi/client.py \
253         lib/rapi/client_utils.py \
254         lib/rapi/connector.py \
255         lib/rapi/rlib2.py
256
257 http_PYTHON = \
258         lib/http/__init__.py \
259         lib/http/auth.py \
260         lib/http/client.py \
261         lib/http/server.py
262
263 confd_PYTHON = \
264         lib/confd/__init__.py \
265         lib/confd/client.py \
266         lib/confd/querylib.py \
267         lib/confd/server.py
268
269 masterd_PYTHON = \
270         lib/masterd/__init__.py \
271         lib/masterd/instance.py
272
273 impexpd_PYTHON = \
274         lib/impexpd/__init__.py
275
276 watcher_PYTHON = \
277         lib/watcher/__init__.py \
278         lib/watcher/nodemaint.py \
279         lib/watcher/state.py
280
281 server_PYTHON = \
282         lib/server/__init__.py \
283         lib/server/confd.py \
284         lib/server/masterd.py \
285         lib/server/noded.py \
286         lib/server/rapi.py
287
288 pytools_PYTHON = \
289         lib/tools/__init__.py \
290         lib/tools/ensure_dirs.py
291
292 utils_PYTHON = \
293         lib/utils/__init__.py \
294         lib/utils/algo.py \
295         lib/utils/filelock.py \
296         lib/utils/hash.py \
297         lib/utils/io.py \
298         lib/utils/log.py \
299         lib/utils/mlock.py \
300         lib/utils/nodesetup.py \
301         lib/utils/process.py \
302         lib/utils/retry.py \
303         lib/utils/text.py \
304         lib/utils/wrapper.py \
305         lib/utils/x509.py
306
307 docrst = \
308         doc/admin.rst \
309         doc/design-2.0.rst \
310         doc/design-2.1.rst \
311         doc/design-2.2.rst \
312         doc/design-2.3.rst \
313         doc/design-htools-2.3.rst \
314         doc/design-2.4.rst \
315         doc/design-2.5.rst \
316         doc/design-draft.rst \
317         doc/design-oob.rst \
318         doc/design-cpu-pinning.rst \
319         doc/design-query2.rst \
320         doc/design-x509-ca.rst \
321         doc/design-http-server.rst \
322         doc/design-impexp2.rst \
323         doc/design-lu-generated-jobs.rst \
324         doc/design-multi-reloc.rst \
325         doc/design-network.rst \
326         doc/design-chained-jobs.rst \
327         doc/design-ovf-support.rst \
328         doc/design-resource-model.rst \
329         doc/cluster-merge.rst \
330         doc/design-shared-storage.rst \
331         doc/design-node-state-cache.rst \
332         doc/design-virtual-clusters.rst \
333         doc/devnotes.rst \
334         doc/glossary.rst \
335         doc/hooks.rst \
336         doc/iallocator.rst \
337         doc/index.rst \
338         doc/install-quick.rst \
339         doc/install.rst \
340         doc/locking.rst \
341         doc/move-instance.rst \
342         doc/news.rst \
343         doc/rapi.rst \
344         doc/security.rst \
345         doc/upgrade.rst \
346         doc/walkthrough.rst
347
348 HS_PROGS = htools/htools
349 HS_BIN_ROLES = hbal hscan hspace
350
351 HS_ALL_PROGS = $(HS_PROGS) htools/test
352 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
353 # we don't add -Werror by default
354 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
355 # extra flags that can be overriden on the command line
356 HEXTRA =
357 # exclude options for coverage reports
358 HPCEXCL = --exclude Main \
359         --exclude Ganeti.Constants \
360         --exclude Ganeti.THH \
361         --exclude Ganeti.HTools.QC \
362         --exclude Ganeti.HTools.QCHelper \
363         --exclude Ganeti.HTools.Version
364
365 HS_LIB_SRCS = \
366         htools/Ganeti/HTools/CLI.hs \
367         htools/Ganeti/HTools/Cluster.hs \
368         htools/Ganeti/HTools/Compat.hs \
369         htools/Ganeti/HTools/Container.hs \
370         htools/Ganeti/HTools/ExtLoader.hs \
371         htools/Ganeti/HTools/Group.hs \
372         htools/Ganeti/HTools/IAlloc.hs \
373         htools/Ganeti/HTools/Instance.hs \
374         htools/Ganeti/HTools/JSON.hs \
375         htools/Ganeti/HTools/Loader.hs \
376         htools/Ganeti/HTools/Luxi.hs \
377         htools/Ganeti/HTools/Node.hs \
378         htools/Ganeti/HTools/PeerMap.hs \
379         htools/Ganeti/HTools/QC.hs \
380         htools/Ganeti/HTools/QCHelper.hs \
381         htools/Ganeti/HTools/Rapi.hs \
382         htools/Ganeti/HTools/Simu.hs \
383         htools/Ganeti/HTools/Text.hs \
384         htools/Ganeti/HTools/Types.hs \
385         htools/Ganeti/HTools/Utils.hs \
386         htools/Ganeti/HTools/Program/Hail.hs \
387         htools/Ganeti/HTools/Program/Hbal.hs \
388         htools/Ganeti/HTools/Program/Hscan.hs \
389         htools/Ganeti/HTools/Program/Hspace.hs \
390         htools/Ganeti/Jobs.hs \
391         htools/Ganeti/Luxi.hs \
392         htools/Ganeti/OpCodes.hs \
393         htools/Ganeti/THH.hs
394
395 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
396 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
397
398 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
399
400 # Note: we use here an order-only prerequisite, as the contents of
401 # _autoconf.py are not actually influencing the html build output: it
402 # has to exist in order for the sphinx module to be loaded
403 # successfully, but we certainly don't want the docs to be rebuilt if
404 # it changes
405 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
406         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
407         | $(BUILT_PYTHON_SOURCES)
408         @test -n "$(SPHINX)" || \
409             { echo 'sphinx-build' not found during configure; exit 1; }
410         @mkdir_p@ $(dir $@)
411         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
412             -d . \
413             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
414             -D release="$(PACKAGE_VERSION)" \
415             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
416         rm -f doc/html/.buildinfo doc/html/objects.inv
417         touch $@
418
419 doc/html: doc/html/index.html
420
421 doc/install-quick.rst: INSTALL
422 doc/news.rst: NEWS
423 doc/upgrade.rst: UPGRADE
424
425 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
426         set -e; \
427         { echo '.. This file is automatically updated at build time from $<.'; \
428           echo '.. Do not edit.'; \
429           echo; \
430           cat $<; \
431         } > $@
432
433 docdot = \
434         doc/arch-2.0.dot \
435         doc/design-2.1-lock-acquire.dot \
436         doc/design-2.1-lock-release.dot
437
438 docpng = $(patsubst %.dot,%.png,$(docdot))
439
440 # Things to build but not to install (add it to EXTRA_DIST if it should be
441 # distributed)
442 noinst_DATA = \
443         devel/upload \
444         doc/html \
445         $(BUILT_EXAMPLES) \
446         doc/examples/bash_completion \
447         $(manhtml)
448
449 gnt_scripts = \
450         scripts/gnt-backup \
451         scripts/gnt-cluster \
452         scripts/gnt-debug \
453         scripts/gnt-group \
454         scripts/gnt-instance \
455         scripts/gnt-job \
456         scripts/gnt-node \
457         scripts/gnt-os
458
459 PYTHON_BOOTSTRAP_SBIN = \
460         daemons/ganeti-confd \
461         daemons/ganeti-masterd \
462         daemons/ganeti-noded \
463         daemons/ganeti-watcher \
464         daemons/ganeti-rapi \
465         $(gnt_scripts)
466
467 PYTHON_BOOTSTRAP = \
468         $(PYTHON_BOOTSTRAP_SBIN) \
469         tools/ensure-dirs
470
471 qa_scripts = \
472         qa/ganeti-qa.py \
473         qa/qa_cluster.py \
474         qa/qa_config.py \
475         qa/qa_daemon.py \
476         qa/qa_env.py \
477         qa/qa_error.py \
478         qa/qa_group.py \
479         qa/qa_instance.py \
480         qa/qa_node.py \
481         qa/qa_os.py \
482         qa/qa_rapi.py \
483         qa/qa_tags.py \
484         qa/qa_utils.py
485
486 bin_SCRIPTS =
487 if WANT_HTOOLS
488 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
489 install-exec-hook:
490         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
491 # FIXME: this is a hardcoded logic, instead of auto-resolving
492         $(LN_S) -f ../../../bin/htools \
493                    $(DESTDIR)$(iallocatorsdir)/hail
494         for role in $(HS_BIN_ROLES); do \
495                 $(LN_S) -f htools \
496                            $(DESTDIR)$(bindir)/$$role ; \
497         done
498 endif
499
500 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
501         @if [ -z "$(HTOOLS)" ]; then \
502           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
503           exit 1; \
504         fi
505         @BINARY=$(@:htools/%=%); \
506         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
507           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
508           exit 1; \
509         fi
510         BINARY=$(@:htools/%=%); $(GHC) --make \
511           $(HFLAGS) \
512           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
513           -osuf $$BINARY.o -hisuf $$BINARY.hi \
514           $(HEXTRA) $@
515
516 # for the htools/test binary, we need to enable profiling/coverage
517 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
518         -fno-warn-monomorphism-restriction -fno-warn-orphans \
519         -fno-warn-missing-methods -fno-warn-unused-imports
520
521 dist_sbin_SCRIPTS = \
522         tools/ganeti-listrunner
523
524 nodist_sbin_SCRIPTS = \
525         $(PYTHON_BOOTSTRAP_SBIN) \
526         daemons/ganeti-cleaner
527
528 python_scripts = \
529         tools/burnin \
530         tools/cfgshell \
531         tools/cfgupgrade \
532         tools/cfgupgrade12 \
533         tools/cluster-merge \
534         tools/confd-client \
535         tools/lvmstrap \
536         tools/move-instance \
537         tools/ovfconverter \
538         tools/setup-ssh \
539         tools/sanitize-config
540
541 dist_tools_SCRIPTS = \
542         $(python_scripts) \
543         tools/kvm-console-wrapper \
544         tools/xm-console-wrapper \
545         tools/master-ip-setup
546
547 pkglib_python_scripts = \
548         daemons/import-export \
549         tools/check-cert-expired
550
551 nodist_pkglib_python_scripts = \
552         tools/ensure-dirs
553
554 pkglib_SCRIPTS = \
555         daemons/daemon-util \
556         tools/kvm-ifup \
557         $(pkglib_python_scripts)
558
559 nodist_pkglib_SCRIPTS = \
560         $(nodist_pkglib_python_scripts)
561
562 EXTRA_DIST = \
563         NEWS \
564         UPGRADE \
565         epydoc.conf.in \
566         pylintrc \
567         autotools/build-bash-completion \
568         autotools/build-rpc \
569         autotools/check-header \
570         autotools/check-python-code \
571         autotools/check-imports \
572         autotools/check-man \
573         autotools/check-news \
574         autotools/check-tar \
575         autotools/check-version \
576         autotools/convert-constants \
577         autotools/docpp \
578         autotools/gen-coverage \
579         autotools/testrunner \
580         $(RUN_IN_TEMPDIR) \
581         daemons/daemon-util.in \
582         daemons/ganeti-cleaner.in \
583         $(pkglib_python_scripts) \
584         devel/upload.in \
585         tools/kvm-ifup.in \
586         $(docdot) \
587         $(docpng) \
588         $(docrst) \
589         doc/conf.py \
590         doc/html \
591         $(BUILT_EXAMPLES:%=%.in) \
592         doc/examples/ganeti.default \
593         doc/examples/ganeti.default-debug \
594         doc/examples/hooks/ethers \
595         doc/examples/gnt-debug/README \
596         doc/examples/gnt-debug/delay0.json \
597         doc/examples/gnt-debug/delay50.json \
598         test/lockperf.py \
599         test/testutils.py \
600         test/mocks.py \
601         $(dist_TESTS) \
602         $(TEST_FILES) \
603         man/footer.rst \
604         $(manrst) \
605         $(maninput) \
606         qa/qa-sample.json \
607         $(qa_scripts) \
608         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
609         $(HS_PROG_SRCS) \
610         htools/lint-hints.hs
611
612 man_MANS = \
613         man/ganeti.7 \
614         man/ganeti-cleaner.8 \
615         man/ganeti-confd.8 \
616         man/ganeti-listrunner.8 \
617         man/ganeti-masterd.8 \
618         man/ganeti-noded.8 \
619         man/ganeti-os-interface.7 \
620         man/ganeti-rapi.8 \
621         man/ganeti-watcher.8 \
622         man/gnt-backup.8 \
623         man/gnt-cluster.8 \
624         man/gnt-debug.8 \
625         man/gnt-group.8 \
626         man/gnt-instance.8 \
627         man/gnt-job.8 \
628         man/gnt-node.8 \
629         man/gnt-os.8 \
630         man/hail.1 \
631         man/hbal.1 \
632         man/hscan.1 \
633         man/hspace.1 \
634         man/htools.1
635
636 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
637 manhtml = $(patsubst %.rst,%.html,$(manrst))
638 mangen = $(patsubst %.rst,%.gen,$(manrst))
639 maninput = \
640         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
641         $(patsubst %.html,%.html.in,$(manhtml)) \
642         man/footer.man man/footer.html $(mangen)
643
644 TEST_FILES = \
645         test/data/bdev-drbd-8.0.txt \
646         test/data/bdev-drbd-8.3.txt \
647         test/data/bdev-drbd-disk.txt \
648         test/data/bdev-drbd-net-ip4.txt \
649         test/data/bdev-drbd-net-ip6.txt \
650         test/data/cert1.pem \
651         test/data/ip-addr-show-dummy0.txt \
652         test/data/ip-addr-show-lo-ipv4.txt \
653         test/data/ip-addr-show-lo-ipv6.txt \
654         test/data/ip-addr-show-lo-oneline-ipv4.txt \
655         test/data/ip-addr-show-lo-oneline-ipv6.txt \
656         test/data/ip-addr-show-lo-oneline.txt \
657         test/data/ip-addr-show-lo.txt \
658         test/data/proc_drbd8.txt \
659         test/data/proc_drbd80-emptyline.txt \
660         test/data/proc_drbd83.txt \
661         test/data/proc_drbd83_sync.txt \
662         test/data/proc_drbd83_sync_krnl2.6.39.txt \
663         test/data/kvm_1.0_help.txt \
664         test/data/kvm_0.15.90_help.txt \
665         test/data/kvm_0.12.5_help.txt \
666         test/data/kvm_0.9.1_help.txt \
667         test/data/sys_drbd_usermode_helper.txt \
668         test/data/ovfdata/compr_disk.vmdk.gz \
669         test/data/ovfdata/config.ini \
670         test/data/ovfdata/corrupted_resources.ovf \
671         test/data/ovfdata/empty.ini \
672         test/data/ovfdata/empty.ovf \
673         test/data/ovfdata/ganeti.mf \
674         test/data/ovfdata/ganeti.ovf \
675         test/data/ovfdata/gzip_disk.ovf \
676         test/data/ovfdata/new_disk.vmdk \
677         test/data/ovfdata/no_disk.ini \
678         test/data/ovfdata/no_disk_in_ref.ovf \
679         test/data/ovfdata/no_os.ini \
680         test/data/ovfdata/no_ovf.ova \
681         test/data/ovfdata/ova.ova \
682         test/data/ovfdata/second_disk.vmdk \
683         test/data/ovfdata/rawdisk.raw \
684         test/data/ovfdata/unsafe_path.ini \
685         test/data/ovfdata/virtualbox.ovf \
686         test/data/ovfdata/wrong_extension.ovd \
687         test/data/ovfdata/wrong_config.ini \
688         test/data/ovfdata/wrong_manifest.mf \
689         test/data/ovfdata/wrong_manifest.ovf \
690         test/data/ovfdata/wrong_ova.ova \
691         test/data/ovfdata/wrong_xml.ovf \
692         test/data/ovfdata/other/rawdisk.raw \
693         test/import-export_unittest-helper
694
695 python_tests = \
696         test/ganeti.asyncnotifier_unittest.py \
697         test/ganeti.backend_unittest.py \
698         test/ganeti.bdev_unittest.py \
699         test/ganeti.cli_unittest.py \
700         test/ganeti.client.gnt_cluster_unittest.py \
701         test/ganeti.client.gnt_instance_unittest.py \
702         test/ganeti.daemon_unittest.py \
703         test/ganeti.cmdlib_unittest.py \
704         test/ganeti.compat_unittest.py \
705         test/ganeti.confd.client_unittest.py \
706         test/ganeti.config_unittest.py \
707         test/ganeti.constants_unittest.py \
708         test/ganeti.errors_unittest.py \
709         test/ganeti.hooks_unittest.py \
710         test/ganeti.ht_unittest.py \
711         test/ganeti.http_unittest.py \
712         test/ganeti.hypervisor_unittest.py \
713         test/ganeti.hypervisor.hv_chroot_unittest.py \
714         test/ganeti.hypervisor.hv_fake_unittest.py \
715         test/ganeti.hypervisor.hv_kvm_unittest.py \
716         test/ganeti.hypervisor.hv_lxc_unittest.py \
717         test/ganeti.hypervisor.hv_xen_unittest.py \
718         test/ganeti.impexpd_unittest.py \
719         test/ganeti.jqueue_unittest.py \
720         test/ganeti.locking_unittest.py \
721         test/ganeti.luxi_unittest.py \
722         test/ganeti.masterd.instance_unittest.py \
723         test/ganeti.mcpu_unittest.py \
724         test/ganeti.netutils_unittest.py \
725         test/ganeti.objects_unittest.py \
726         test/ganeti.opcodes_unittest.py \
727         test/ganeti.ovf_unittest.py \
728         test/ganeti.qlang_unittest.py \
729         test/ganeti.query_unittest.py \
730         test/ganeti.rapi.baserlib_unittest.py \
731         test/ganeti.rapi.client_unittest.py \
732         test/ganeti.rapi.resources_unittest.py \
733         test/ganeti.rapi.rlib2_unittest.py \
734         test/ganeti.rpc_unittest.py \
735         test/ganeti.runtime_unittest.py \
736         test/ganeti.serializer_unittest.py \
737         test/ganeti.ssh_unittest.py \
738         test/ganeti.tools.ensure_dirs_unittest.py \
739         test/ganeti.uidpool_unittest.py \
740         test/ganeti.utils.algo_unittest.py \
741         test/ganeti.utils.filelock_unittest.py \
742         test/ganeti.utils.hash_unittest.py \
743         test/ganeti.utils.io_unittest.py \
744         test/ganeti.utils.log_unittest.py \
745         test/ganeti.utils.mlock_unittest.py \
746         test/ganeti.utils.nodesetup_unittest.py \
747         test/ganeti.utils.process_unittest.py \
748         test/ganeti.utils.retry_unittest.py \
749         test/ganeti.utils.text_unittest.py \
750         test/ganeti.utils.wrapper_unittest.py \
751         test/ganeti.utils.x509_unittest.py \
752         test/ganeti.utils_unittest.py \
753         test/ganeti.workerpool_unittest.py \
754         test/cfgupgrade_unittest.py \
755         test/docs_unittest.py \
756         test/pycurl_reset_unittest.py \
757         test/tempfile_fork_unittest.py
758 if HAS_FAKEROOT
759 python_tests += test/ganeti.utils.io_unittest-runasroot.py
760 endif
761
762 haskell_tests = htools/test
763
764 dist_TESTS = \
765         test/check-cert-expired_unittest.bash \
766         test/daemon-util_unittest.bash \
767         test/ganeti-cleaner_unittest.bash \
768         test/import-export_unittest.bash \
769         $(python_tests)
770
771 nodist_TESTS =
772 if WANT_HTOOLSTESTS
773 nodist_TESTS += $(haskell_tests)
774 endif
775
776 TESTS = $(dist_TESTS) $(nodist_TESTS)
777
778 # Environment for all tests
779 PLAIN_TESTS_ENVIRONMENT = \
780         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) \
781         FAKEROOT=$(FAKEROOT_PATH) $(RUN_IN_TEMPDIR)
782
783 # Environment for tests run by automake
784 TESTS_ENVIRONMENT = \
785         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
786
787 all_python_code = \
788         $(dist_sbin_SCRIPTS) \
789         $(python_scripts) \
790         $(pkglib_python_scripts) \
791         $(nodist_pkglib_python_scripts) \
792         $(python_tests) \
793         $(pkgpython_PYTHON) \
794         $(client_PYTHON) \
795         $(hypervisor_PYTHON) \
796         $(rapi_PYTHON) \
797         $(server_PYTHON) \
798         $(pytools_PYTHON) \
799         $(http_PYTHON) \
800         $(confd_PYTHON) \
801         $(masterd_PYTHON) \
802         $(impexpd_PYTHON) \
803         $(utils_PYTHON) \
804         $(watcher_PYTHON) \
805         $(noinst_PYTHON) \
806         $(qa_scripts)
807
808 srclink_files = \
809         man/footer.rst \
810         test/check-cert-expired_unittest.bash \
811         test/daemon-util_unittest.bash \
812         test/ganeti-cleaner_unittest.bash \
813         test/import-export_unittest.bash \
814         $(all_python_code) \
815         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
816
817 check_python_code = \
818         $(BUILD_BASH_COMPLETION) \
819         $(CHECK_IMPORTS) \
820         $(CHECK_HEADER) \
821         $(DOCPP) \
822         $(all_python_code)
823
824 lint_python_code = \
825         ganeti \
826         ganeti/http/server.py \
827         $(dist_sbin_SCRIPTS) \
828         $(python_scripts) \
829         $(pkglib_python_scripts) \
830         $(BUILD_BASH_COMPLETION) \
831         $(CHECK_IMPORTS) \
832         $(CHECK_HEADER) \
833         $(DOCPP) \
834         $(PYTHON_BOOTSTRAP)
835
836 standalone_python_modules = \
837         lib/rapi/client.py \
838         tools/ganeti-listrunner
839
840 pep8_python_code = \
841         ganeti \
842         ganeti/http/server.py \
843         $(dist_sbin_SCRIPTS) \
844         $(python_scripts) \
845         $(pkglib_python_scripts) \
846         $(BUILD_BASH_COMPLETION) \
847         $(CHECK_HEADER) \
848         $(DOCPP) \
849         $(PYTHON_BOOTSTRAP) \
850         qa
851
852 test/daemon-util_unittest.bash: daemons/daemon-util
853
854 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
855
856 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
857         sed -f $(REPLACE_VARS_SED) < $< > $@
858         chmod +x $@
859
860 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
861         sed -f $(REPLACE_VARS_SED) < $< > $@
862         chmod u+x $@
863
864 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
865         sed -f $(REPLACE_VARS_SED) < $< > $@
866         chmod +x $@
867
868 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
869         sed -f $(REPLACE_VARS_SED) < $< > $@
870
871 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
872         sed -f $(REPLACE_VARS_SED) < $< > $@
873
874 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
875         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
876         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
877
878 doc/%.png: doc/%.dot
879         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
880         $(DOT) -Tpng -o $@ $<
881
882 man/footer.man: man/footer.rst
883         @test -n "$(PANDOC)" || \
884           { echo 'pandoc' not found during configure; exit 1; }
885         $(PANDOC) -f rst -t man -o $@ $<
886
887 man/footer.html: man/footer.rst
888         @test -n "$(PANDOC)" || \
889           { echo 'pandoc' not found during configure; exit 1; }
890         $(PANDOC) -f rst -t html -o $@ $<
891
892 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
893         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
894
895 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
896         @test -n "$(PANDOC)" || \
897           { echo 'pandoc' not found during configure; exit 1; }
898         set -o pipefail ; \
899         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
900           sed -e 's/\\@/@/g' > $@
901         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
902
903 man/%.html.in: man/%.gen man/footer.html
904         @test -n "$(PANDOC)" || \
905           { echo 'pandoc' not found during configure; exit 1; }
906         set -o pipefail ; \
907         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
908           sed -e 's/\\@/@/g' > $@
909
910 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
911         sed -f $(REPLACE_VARS_SED) < $< > $@
912
913 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
914         sed -f $(REPLACE_VARS_SED) < $< > $@
915
916 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
917         sed -f $(REPLACE_VARS_SED) < $< > $@
918
919 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
920         sed -f $(REPLACE_VARS_SED) < $< > $@
921
922 epydoc.conf: epydoc.conf.in Makefile
923         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
924
925 vcs-version:
926         if test -d .git; then \
927           git describe > $@; \
928         elif test ! -f $@ ; then \
929           echo "Cannot auto-generate $@ file"; exit 1; \
930         fi
931
932 .PHONY: regen-vcs-version
933 regen-vcs-version:
934         set -e; \
935         cd $(srcdir); \
936         if test -d .git; then \
937           rm -f vcs-version; \
938           $(MAKE) vcs-version; \
939         fi
940
941 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
942         set -e; \
943         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
944         sed -e "s/%ver%/$$VCSVER/" < $< > $@
945
946 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
947         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
948         | lib/_vcsversion.py
949         set -e; \
950         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
951
952 lib/_autoconf.py: Makefile | lib/.dir
953         set -e; \
954         { echo '# This file is automatically generated, do not edit!'; \
955           echo '#'; \
956           echo ''; \
957           echo '"""Build-time configuration for Ganeti.'; \
958           echo '';\
959           echo 'This file is autogenerated by the build process.'; \
960           echo 'For any changes you need to re-run ./configure (and'; \
961           echo 'not edit by hand).'; \
962           echo ''; \
963           echo '"""'; \
964           echo ''; \
965           echo '# pylint: disable=C0301,C0324'; \
966           echo '# because this is autogenerated, we do not want'; \
967           echo '# style warnings' ; \
968           echo ''; \
969           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
970           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
971           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
972           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
973           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
974           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
975           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
976           echo "SYSCONFDIR = '$(sysconfdir)'"; \
977           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
978           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
979           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
980           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
981           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
982           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
983           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
984           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
985           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
986           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
987           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
988           echo "KVM_PATH = '$(KVM_PATH)'"; \
989           echo "IP_PATH = '$(IP_PATH)'"; \
990           echo "SOCAT_PATH = '$(SOCAT)'"; \
991           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
992           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
993           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
994           echo "TOOLSDIR = '$(toolsdir)'"; \
995           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
996           echo "PKGLIBDIR = '$(pkglibdir)'"; \
997           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
998           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
999           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1000           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1001           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1002           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1003           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1004           echo "RAPI_USER = '$(RAPI_USER)'"; \
1005           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1006           echo "CONFD_USER = '$(CONFD_USER)'"; \
1007           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1008           echo "NODED_USER = '$(NODED_USER)'"; \
1009           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1010           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1011           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1012           if [ "$(HTOOLS)" ]; then \
1013             echo "HTOOLS = True"; \
1014           else \
1015             echo "HTOOLS = False"; \
1016           fi; \
1017           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1018         } > $@
1019
1020 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1021         set -e; \
1022         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1023         { echo '# This file is automatically generated, do not edit!'; \
1024           echo '#'; \
1025           echo ''; \
1026           echo '"""Build-time VCS version number for Ganeti.'; \
1027           echo '';\
1028           echo 'This file is autogenerated by the build process.'; \
1029           echo 'For any changes you need to re-run ./configure (and'; \
1030           echo 'not edit by hand).'; \
1031           echo ''; \
1032           echo '"""'; \
1033           echo ''; \
1034           echo '# pylint: disable=C0301,C0324'; \
1035           echo '# because this is autogenerated, we do not want'; \
1036           echo '# style warnings' ; \
1037           echo ''; \
1038           echo "VCS_VERSION = '$$VCSVER'"; \
1039         } > $@
1040
1041 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1042         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1043
1044 $(REPLACE_VARS_SED): Makefile
1045         set -e; \
1046         { echo 's#@PREFIX@#$(prefix)#g'; \
1047           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1048           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1049           echo 's#@BINDIR@#$(bindir)#g'; \
1050           echo 's#@SBINDIR@#$(sbindir)#g'; \
1051           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1052           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1053           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1054           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1055           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1056           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1057           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1058           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1059           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1060           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1061           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1062           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1063           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1064           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1065           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1066           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1067           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1068           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1069           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1070         } > $@
1071
1072 # Using deferred evaluation
1073 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1074 daemons/ganeti-watcher: MODULE = ganeti.watcher
1075 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1076 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1077
1078 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1079         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1080         set -e; \
1081         { echo '#!/usr/bin/python'; \
1082           echo '# This file is automatically generated, do not edit!'; \
1083           echo "# Edit $(MODULE) instead."; \
1084           echo; \
1085           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1086           echo; \
1087           echo '# pylint: disable=C0103'; \
1088           echo '# C0103: Invalid name'; \
1089           echo; \
1090           echo 'import sys'; \
1091           echo 'import $(MODULE) as main'; \
1092           echo; \
1093           echo '# Temporarily alias commands until bash completion'; \
1094           echo '# generator is changed'; \
1095           echo 'if hasattr(main, "commands"):'; \
1096           echo '  commands = main.commands # pylint: disable=E1101'; \
1097           echo 'if hasattr(main, "aliases"):'; \
1098           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1099           echo; \
1100           echo 'if __name__ == "__main__":'; \
1101           echo '  sys.exit(main.Main())'; \
1102         } > $@
1103         chmod u+x $@
1104
1105 # We need to create symlinks because "make distcheck" will not install Python
1106 # files when building.
1107 stamp-srclinks: Makefile | $(all_dirfiles)
1108         set -e; \
1109         for i in $(srclink_files); do \
1110                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1111                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1112                 fi; \
1113         done
1114         touch $@
1115
1116 .PHONY: ganeti
1117 ganeti:
1118         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1119
1120 .PHONY: check-dirs
1121 check-dirs: $(BUILT_SOURCES)
1122         @set -e; \
1123         find . -type d \( \( -name . \) -o \( \
1124                 -name .git -o \
1125                 -name autom4te.cache \
1126                 \) -prune -o -print \) | { \
1127                 error=; \
1128                 while read dir; do \
1129                         case "$$dir" in \
1130                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1131                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1132                         esac; \
1133                 done; \
1134                 for dir in $(DIRS); do \
1135                         if ! test -d "$$dir"; then \
1136                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1137                                 error=1; \
1138                         fi \
1139                 done; \
1140                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1141         }
1142
1143 .PHONY: check-local
1144 check-local: check-dirs $(BUILT_SOURCES)
1145         $(CHECK_PYTHON_CODE) $(check_python_code)
1146         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1147         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1148         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1149         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1150         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1151         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1152                 echo "Incorrect version in README, expected $$expver"; \
1153                 exit 1; \
1154         fi; \
1155         for file in doc/iallocator.rst doc/hooks.rst; do \
1156                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1157                         "Documents Ganeti version $$expver"; then \
1158                         echo "Incorrect version in $$file, expected $$expver"; \
1159                         exit 1; \
1160                 fi; \
1161         done
1162
1163 .PHONY: hs-check
1164 hs-check: htools/test
1165         @rm -f test.tix
1166         ./htools/test
1167
1168 # E111: indentation is not a multiple of four
1169 # E261: at least two spaces before inline comment
1170 # E501: line too long (80 characters)
1171 PEP8_IGNORE = E111,E261,E501
1172
1173 # For excluding pep8 expects filenames only, not whole paths
1174 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1175
1176 .PHONY: lint
1177 lint: $(BUILT_SOURCES)
1178         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1179         if test -z "$(PEP8)"; then \
1180                 echo '"pep8" not found during configure' >&2; \
1181         else \
1182                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1183                         $(pep8_python_code); \
1184         fi
1185         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1186         cd $(top_srcdir)/qa && \
1187           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1188           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1189
1190 .PHONY: hlint
1191 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1192         if tty -s; then C="-c"; else C=""; fi; \
1193         hlint --report=doc/hs-lint.html --cross $$C \
1194           --ignore "Use first" \
1195           --ignore "Use comparing" \
1196           --ignore "Use on" \
1197           --ignore "Use Control.Exception.catch" \
1198           --ignore "Reduce duplication" \
1199           --hint htools/lint-hints \
1200           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1201
1202 # a dist hook rule for updating the vcs-version file; this is
1203 # hardcoded due to where it needs to build the file...
1204 dist-hook:
1205         $(MAKE) regen-vcs-version && \
1206         rm -f $(top_distdir)/vcs-version && \
1207         cp -p $(srcdir)/vcs-version $(top_distdir)
1208
1209 # a distcheck hook rule for catching revision control directories
1210 distcheck-hook:
1211         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1212                 echo "Found revision control files in final archive." 1>&2; \
1213                 exit 1; \
1214         fi
1215         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1216                 echo "Found Python byte code in final archive." 1>&2; \
1217                 exit 1; \
1218         fi
1219         if find $(top_distdir) -name '*~' | grep .; then \
1220                 echo "Found backup files in final archive." 1>&2; \
1221                 exit 1; \
1222         fi
1223 # Empty files or directories should not be distributed. They can cause
1224 # unnecessary warnings for packagers. Directories used by automake during
1225 # distcheck must be excluded.
1226         if find $(top_distdir) -empty -and -not \( \
1227                         -path $(top_distdir)/_build -or \
1228                         -path $(top_distdir)/_inst \) | grep .; then \
1229                 echo "Found empty files or directories in final archive." 1>&2; \
1230                 exit 1; \
1231         fi
1232         if test -n "$(BUILD_RELEASE)" && \
1233            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1234                 echo "Found unreleased version in NEWS." >&2; \
1235                 exit 1; \
1236         fi
1237
1238 # When building a release, stricter checks should be used
1239 distcheck-release dist-release: export BUILD_RELEASE = 1
1240 distcheck-release: distcheck
1241
1242 dist-release: dist
1243         set -e; \
1244         for i in $(DIST_ARCHIVES); do \
1245                 echo -n "Checking $$i ... "; \
1246                 autotools/check-tar < $$i; \
1247                 echo OK; \
1248         done
1249
1250 install-exec-local:
1251         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1252           "$(DESTDIR)${localstatedir}/log/ganeti" \
1253           "$(DESTDIR)${localstatedir}/run/ganeti"
1254
1255 # To avoid conflicts between directory names and other targets, a file inside
1256 # the directory is used to ensure its existence.
1257 %.dir:
1258         @mkdir_p@ $* && touch $@
1259
1260 .PHONY: apidoc
1261 if WANT_HTOOLSAPIDOC
1262 apidoc: py-apidoc hs-apidoc
1263 else
1264 apidoc: py-apidoc
1265 endif
1266
1267 .PHONY: py-apidoc
1268 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1269         $(RUN_IN_TEMPDIR) epydoc -v \
1270                 --conf $(CURDIR)/epydoc.conf \
1271                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1272
1273 .PHONY: hs-apidoc
1274 hs-apidoc: $(HS_BUILT_SRCS)
1275         @test -n "$(HSCOLOUR)" || \
1276             { echo 'HsColour' not found during configure; exit 1; }
1277         @test -n "$(HADDOCK)" || \
1278             { echo 'haddock' not found during configure; exit 1; }
1279         rm -rf $(APIDOC_HS_DIR)/*
1280         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1281         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1282         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1283         set -e ; \
1284         cd htools; \
1285         if [ "$(HTOOLS_NOCURL)" ]; \
1286         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1287         else OPTGHC=""; \
1288         fi; \
1289         if [ "$(HTOOLS_PARALLEL3)" ]; \
1290         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1291         fi; \
1292         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1293         for file in $$RELSRCS; do \
1294                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1295                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1296         done ; \
1297         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1298                 -t ganeti-htools -p haddock-prologue \
1299                 --source-module="%{MODULE/.//}.html" \
1300                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1301                 $$OPTGHC \
1302                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1303
1304 .PHONY: TAGS
1305 TAGS: $(BUILT_SOURCES)
1306         rm -f TAGS
1307         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1308           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1309           -path './qa/*.py' | \
1310           etags -l python -
1311
1312 .PHONY: coverage
1313 if WANT_HTOOLS
1314 coverage: py-coverage hs-coverage
1315 else
1316 coverage: py-coverage
1317 endif
1318
1319 .PHONY: py-coverage
1320 py-coverage: $(BUILT_SOURCES) $(python_tests)
1321         set -e; \
1322         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1323         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1324         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1325         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1326         $(python_tests)
1327
1328 .PHONY: hs-coverage
1329 hs-coverage: $(haskell_tests)
1330         cd htools && rm -f *.tix *.mix && ./test
1331         @mkdir_p@ $(COVERAGE_HS_DIR)
1332         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1333         hpc report htools/test $(HPCEXCL)
1334         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1335
1336 # Special "kind-of-QA" target for htools, needs special setup (all
1337 # tools compiled with -fhpc)
1338 .PHONY: live-test
1339 live-test: all
1340         set -e ; \
1341         cd htools; \
1342         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1343         rm -f *.tix *.mix; \
1344         ./live-test.sh; \
1345         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1346           --output=live-test.tix ; \
1347         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1348         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1349                 --srcdir=.. $(HPCEXCL) ; \
1350         hpc report --srcdir=.. live-test $(HPCEXCL)
1351
1352 commit-check: distcheck lint apidoc
1353
1354 -include ./Makefile.local
1355
1356 # vim: set noet :